package convWinChar;
#------------------------------------------------------------------------------
# Shift-JISp Windows @ˑϊpbP[W
# based on http://www2s.biglobe.ne.jp/~cru/library/junk/depwin.pl
#				by DEX
#				EMAIL : dex@basil.freemail.ne.jp
#				HP    : http://www1.u-netsurf.ne.jp/~dex/
# R[hFShift-JIS + LF
#
# [pr]
# Shift-JIS -> EUCϊ𒼐ڍsƁA@ˑB
# ̑OƂčsB
# ܂A@ˑ̃`FbNȂǁB
#
# [XV]
# 2004/07/16 Ver 1.00
# EVK쐬
#
#------------------------------------------------------------------------------

require 5.004;
use strict;

#------------------------------------------------------------------------------
# O[oϐ
#------------------------------------------------------------------------------

# AXL[R[hESJIS 2oCgESJIS 3oCg̐K\
my($ascii) = '[\x00-\x7F]';
my($sjis_twoBytes) = '[\x81-\x9F\xE0-\xFC][\x40-\x7E\x80-\xFC]';
# pJi13(\x87),89-92(\xED\xEE),115-119(\xFA-\xFC)
my($sjis_pattern) = '[\xA0-\xDF]|[\x87\xED\xEE\xFA-\xFC][\x40-\x7E\x80-\xFC]';

# ϊe[u
my(%conv_data) = (
	0xA0=>		# pJi
	'@ B u v A E  @ B D F H    b [
	A C E G I J L N P R T V X Z \ ^ ` c e g
	i j k  m n q t w z } ~        
	     J K',
	
	0x8740=>		# 13
	'(1) (2) (3) (4) (5) (6) (7) (8) (9)
	(10) (11) (12) (13) (14) (15) (16)
	(17) (18) (19) (20) I II III IV
	V VI VII VIII IX X . ~
	L Z` [g O g A[ wN^[ bg
	bg J[ h Zg p[Zg ~o[ y[W mm
	cm km mg kg cc m^2         ',
	
	0x8780=>		# 13
	'" ,, No. K.K. Tel () () () ()
	(E) () (L) ()  吳 a
	      
	 k    ',
	
	0xEEEF=>		# 92
	q{i ii iii iv v vi vii viii ix x  | ' ''},
	
	0xFA40=>		# 115
	q{i ii iii iv v vi vii viii ix x
	I II III IV V VI VII VIII IX X  | ' ''
	() No. Tel  },
);
my(%conv_table); # ϊe[u

init(); # 1xBnewƃIuWFNg쐬̓xɍsĂ܂߁B

#------------------------------------------------------------------------------
# Windows @ˑϊ
#
# ӁF͂Shift-JISB𒼐ڏB
# IN	$rStr	Ώۂւ̃t@X
# OUT		tΒuAtȂ0ԂB
#
# 
# use lib '.';
# use strict;
# use convWinChar;
# my($str) = 'uΏە';
# my($o) = new convWinChar;
# my($count) += $o->convWindowsChar(\$str);
#------------------------------------------------------------------------------
sub convWindowsChar {
	my($self, $rStr) = @_;
	my($found_count) = $$rStr =~ s/\G((?:$ascii|$sjis_twoBytes)*?)($sjis_pattern)/$1.($conv_table{$2}||'')/oeg;
	return $found_count;
}

#------------------------------------------------------------------------------
# Windows @ˑϊAhtml^Oň
#
# ӁF͂Shift-JISB𒼐ڏB
# IN	$rStr	Ώۂւ̃t@X
# OUT		tΒuAtȂ0ԂB
#------------------------------------------------------------------------------
sub markingWindowsChar {
	my($self, $rStr) = @_;
	my($found_count) = $$rStr =~ s%\G((?:$ascii|$sjis_twoBytes)*?)($sjis_pattern)%"$1<FONT COLOR=red>".($conv_table{$2}||'')."</FONT>"%oeg;
	$$rStr =~ s|</FONT><FONT COLOR=red>||ig;	# dFONT^O폜
	return $found_count;
}

#------------------------------------------------------------------------------
# Windows @ˑ
#
# IN	$rStr	Ώۂւ̃t@X
# OUT		t@ˑ̕ԂBtȂ '' ԂB
#------------------------------------------------------------------------------
sub isWindowsChar {
	my($self, $rStr) = @_;
	return join('', $$rStr =~ m/\G(?:$ascii|$sjis_twoBytes)*?((?:$sjis_pattern)+)/og);
}

#------------------------------------------------------------------------------
# RXgN^
#------------------------------------------------------------------------------
sub new {
	my($class) = ref($_[0]) || $_[0];
	my($self) = {};
	bless $self,$class;
}

#------------------------------------------------------------------------------
# fXgN^
#------------------------------------------------------------------------------
sub DESTROY{
	my($self) = shift;
}

#------------------------------------------------------------------------------
# Windows @ˑ̕ϊe[u
#------------------------------------------------------------------------------
sub init
{
	foreach my $base_code (keys %conv_data){
		foreach ( split(/\s+/, $conv_data{$base_code}) ){
			my($char_code) = pack('C*',$base_code/256,$base_code%256);
			$char_code =~ tr/\0//d; # 1oCg̔pJiϊp
			$conv_table{$char_code} = $_;
			$base_code++;
		}
	}
}

1;
